// $Id: copy.js,v 1.1.2.1 2011/01/16 13:27:12 pounard Exp $

/**
 * @file
 * Copy to clipboard helper. This file IS NOT part of the jquery.copy plugin.
 */

(function ($) {
  Drupal.behaviors.OoxCopyToClipboard = {
    attach: function( context ) {
      $('.copy-to-clipboard:not(.clip-processed)', context)
        .addClass("clip-processed")
        .unbind('click')
        // Bind click event on selected element.
        .click(function( event ) {
          event.preventDefault();
          var rel = $(this).attr('rel');
          if (rel) {
            // Check we have something to clip. In most case, target and
            // clickable element will come into the same context.
            var target = $('#' + rel, context);
            if (target.length) {
              // Use jquery.copy plugin.
              $.copy(target.html());
            }
          }
          return false;
        });
    }
  };
})(jQuery);
