<?php
// $Id: Interface.php,v 1.1.2.1 2011/01/04 18:23:28 pounard Exp $

/**
 * Oox_Optionable_Interface storage handler interface.
 */
interface Oox_Optionable_Storage_Interface
{
  /**
   * Load an Oox_Optionable_Interface instance.
   * 
   * @param int $oid
   *   Oox_Optionable_Interface instance unique identifier.
   * @param IOptionnable $object = NULL
   *   (optional) If you are trying to load options for an already loaded
   *   instance, pass it here. Notice that no class or registry type checks
   *   will be done.
   *   If you use this parameter, the object won't be statically cached.
   * 
   * @return Oox_Optionable_Interface
   *   Fully loaded object. If $object parameter is set, return the exact same
   *   instance.
   * 
   * @throws Oox_Exception
   *   If section does not exists or registry has not been found.
   */
  public function load($oid, Oox_Optionable_Interface $object = NULL);

  /**
   * Insert or update an instance. If this instance does not exists in
   * database, its own identifier will be set.
   * 
   * @param Oox_Optionable_Interface $options
   *   Section to save.
   * @param array $parent = NULL
   *   (optional) This is an internal parameter. Oox_Optionable can be saved by
   *   cascading Oox_Optionable_Interface into one another. This can help saving
   *   objects that provides the Oox_Optionable_Interface interface within
   *   anothers without having to deal with cascading save yourself.
   *   This parameter will keep a list of already saved Oox_Optionable_Interface
   *   interface identifiers, and will break circular dependencies save attempt.
   * 
   * @throws Oox_Exception
   *   In case of any error.
   */
  public function save(Oox_Optionable_Interface $options, $parent = NULL, $parent_name = NULL);

  /**
   * Delete options for the given options identifier.
   */
  public function delete($oid);
}
