<?php

/**
 * Default implementation that can serve as objects base for implementing
 * the Oox_Registrable_Interface interface.
 * 
 * Schema_Exportable_Interface is just a convenience. Per default it only
 * will give back the given configuration instance. For modules that would
 * want to fully and properly implement exportable object, the getSchema()
 * method should be overrided conveniently.
 */
abstract class Oox_Registrable_Abstract
  implements Oox_Registrable_Interface
{
  /**
   * @var string
   */
  protected $_module;

  /**
   * @see Oox_Registrable_Interface::setModule()
   */
  public final function _setModule($module) {
    $this->_module = $module;
    return $this;
  }

  /**
   * @see Oox_Registrable_Interface::getModule()
   */
  public final function getModule() {
    return $this->_module;
  }

  /**
   * @var string
   */
  protected $_registryType;

  /**
   * @see Oox_Registrable_Interface::_setRegistryType()
   */
  public function _setRegistryType($type) {
    $this->_registryType = $type;
    return $this;
  }

  /**
   * @see Oox_Registrable_Interface::getRegistryType()
   */
  public function getRegistryType() {
    return $this->_registryType;
  }

  /**
   * @see Oox_Registrable_Interface::getRegistry()
   */
  public function getRegistry() {
    return Oox_Registry::getInstance($this->_registryType);
  }

  /**
   * @var string
   */
  protected $_type;

  /**
   * @see Oox_Registrable_Interface::_setType()
   */
  public final function _setType($type) {
    $this->_type = $type;
    return $this;
  }

  /**
   * @see Oox_Registrable_Interface::getType()
   */
  public final function getType() {
    return $this->_type;
  }
}