<?php
// $Id: Interface.php,v 1.1.2.1 2011/01/04 18:23:28 pounard Exp $

/**
 * This interface represents any kind of objects that can be rendered to end
 * user on site.
 */
interface Oox_Renderable_Interface
{
  /**
   * Render the full, final output.
   * 
   * @param string $viewMode = Oox_Renderable::VIEW_MODE_DEFAULT
   *   (optional) View mode to use for rendering.
   * 
   * @return string|array
   *   (x)html output or build array ready for drupal_render().
   */
  public function render($viewMode = Oox_Renderable::VIEW_MODE_DEFAULT);
}
