// $Id$

/**
 * @file
 * Dialog helper for formable elements.
 */

(function ($) {
  Drupal.behaviors.Formable = {
    attach: function( context ) {
      // Build the element array.
      $('.oox-dialog:not(.oox-dialog-processed)', context)
        .addClass('oox-dialog-processed')
        .each(function () {
          var $this = $(this),
              link = $this.find('.oox-dialog-open'),
              content = $this.find('.oox-dialog-content');

          // FIXME: Provide detach handler if form is not AJAX.
          // detach() behavior should probably be better, at least this works.
          $this.parents('form').submit(function (event) {
            var container = $('<div style="display: none;"></div>');
            $this.append(container);
            container.append(content);
          });

          content.dialog({
            autoOpen: false,
            draggable: false,
            modal: true,
            width: 500
          });

          link.css({cursor: 'pointer'}).click(function ( event ) {
            event.stopPropagation();
            event.preventDefault();
            content.dialog('open');
            return false;
          });
        });
    },

    /**
     * Detach implementation will place back form elements into the original
     * form, because the dialog content may be removed from it.
     */
    /*
    detach: function( context ) {
      $('.oox-dialog.oox-dialog-processed)', context)
        .removeClass('.oox-dialog-processed')
        .each(function () {
          var $this = $(this),
              content = $this.data('oox-dialog-content');
          $this.append(content);
        });
    }
     */
  };
})(jQuery);
