<?php

/**
 * Class that will do an internal static configuration cache, stored into any
 * cache bin. This will be probably always what you will manipulate in the
 * future once all Schemas have been loaded.
 */
interface Schema_Cached_Interface extends Schema_Interface
{
  /**
   * Restore the current object from cache.
   */
  public function cacheLoad();

  /**
   * Save current object state into cache.
   * 
   * This method should never be called except by main handling module.
   */
  public function cacheSave($force = TRUE);

  /**
   * Clear static and binary cache.
   */
  public function cacheClear();
}
