<?php

/**
 * Base implementation for readers from a raw string.
 * 
 * This implementation will also serve as base for file based implementations.
 */
abstract class Schema_Reader_String implements Schema_Reader_Interface
{
  /**
   * @var string
   */
  protected $_buffer;

  /**
   * Read from buffer.
   * 
   * @return Schema_Readonly_Interface
   */
  public abstract function readFromBuffer($buffer);

  /**
   * @see Schema_Reader_Interface::read()
   */
  public function read() {
    if (!isset($this->_buffer)) {
      throw new Schema_Exception("Attempt to read a schema from a plain string while buffer is not set.");
    }
    return $this->readFromBuffer($this->_buffer);
  }

  public function __construct($buffer = NULL) {
    $this->_buffer = $buffer;
  }
}
