<?php

/**
 * Writer is the instance that is able, from any Schema_Readonly_Interface
 * instance to create a full and valid string buffer that respect a specific
 * file format.
 * 
 * This class is the base class for all writers.
 */
abstract class Schema_Writer
{
  /**
   * @var Exportable_Interface
   */
  protected $_exportable;

  /**
   * Default constructor.
   */
  public function __construct(Schema_Readonly_Interface $exportable) {
    $this->_exportable = $exportable;
  }

  /**
   * Writer must be able to convert schema to string for plain export.
   */
  public abstract function __toString();
}
