<?php

/**
 * @file
 * Testing pages, NOT unit testing.
 * 
 * Unit testing will come when the time is right (should be right now I'm just
 * too lazzy to do it).
 */

function oox_schema_test_page() {
  $content = array();

  $filled = db_select('oox_schema_system', 's');
  $filled->addExpression('COUNT(*)');
  $filled = $filled->execute()->fetchField();

  // Ugly stuff here.
  if (!$filled) {
    // Fill up what we got.
    foreach (module_implements('config_schema') as $module) {
      $array = module_invoke($module, 'config_schema');
      foreach ($array as $name => $default_value) {
        $insert = db_insert('oox_schema_system')
          ->fields(array('name', 'value'), array($name, serialize($default_value)))
          ->execute();
      }
    }
  }
  // Erase cache, we don't need it right now.
  config_get_object()->cacheClear();

  $max = 500000;
  $start = microtime(TRUE);

  $content[]['#markup'] = '<h2>Configuration schema test</h2>';

  $content[]['#markup'] = "<h3>site.themes.default</h3>";
  $content[]['#markup'] = '<pre>' . print_r(config_get('site.themes.default'), TRUE) . '</pre>';

  // Force cache save, because some of the later operations will disable it.
  config_get_object()->cacheSave();

  //$config = _config_get_object();
  for ($i = 0; $i < $max; $i++) {
    config_get('site.themes.default');
    // Using the object directly divides per 2 the time needed to execute
    // the page. Good thought is that developers should probably always
    // access it directly when possible.
    //$config->get('site.themes.default');
  }

  // Testing JSON export.
  $writer = new Schema_Writer_Json(config_get_object());
  $content[]['#markup'] = "<h3>Schema_System Json output</h3>";
  $content[]['#markup'] = '<pre>' . print_r((string) $writer, TRUE) . '</pre>';

  // Not bad, 10000 json_encode() took 4 secs on my box.
  for ($i = 0; $i < 10000; $i++) {
  // $test = (string) $writer;
  }

  $stop = microtime(TRUE);

  // Testing operation reversal.
  $config = config_get_object();
  $buffer_original = (string) new Schema_Writer_Json($config);
  $reader = new Schema_Reader_Json($buffer_original);
  $json_config = $reader->read();
  $buffer_second = (string) new Schema_Writer_Json($json_config);
  if ($buffer_original != $buffer_second) {
    die("no match!");
  }
  //print_r($json_config);die();

  $content[]['#markup'] = '<h2>Status</h2>';
  $content[] = array(
    '#prefix' => '<p><em>',
    '#suffix' => '</em></p>',
    '#markup' => "This page did " . $max . " config_get() calls and 1000 JSON exports",
  );
  $content[] = array(
    '#prefix' => '<p><em>',
    '#suffix' => '</em></p>',
    '#markup' => "This page took " . (($stop - $start) * 1000) . " ms",
  );

  return $content;
}

function oox_schema_test_system_page() {
  $content = array();

  // Fetch system config schema.
  $config = config_get_object();
  $content[]['#markup'] = "<h3>site.themes.default</h3>";
  $content[]['#markup'] = '<pre>' . print_r($config->get('site.themes.default'), TRUE) . '</pre>';

  $content[]['#markup'] = "<h3>print_r()</h3>";
  $content[]['#markup'] = '<pre>' . print_r($config, TRUE) . '</pre>';

  // Now let's merge it a bit.
  $overrides = new Schema_Array(array('site' => array('themes' => array('default' => 'some_new_theme'))));
  // This once should be über fast.
  $start = microtime(TRUE);
  $config->override($overrides);
  $stop = microtime(TRUE);
  $content[] = array(
    '#prefix' => '<p><em>',
    '#suffix' => '</em></p>',
    '#markup' => "Override took " . (($stop - $start) * 1000) . " ms",
  );
  $content[]['#markup'] = "<h3>Once overrided, print_r()</h3>";
  $content[]['#markup'] = '<pre>' . print_r($config, TRUE) . '</pre>';

  // toArray() triggers full object load.
  $array = $config->toArray();
  $content[]['#markup'] = "<h3>Once overrided, toArray()</h3>";
  $content[]['#markup'] = '<pre>' . print_r($array, TRUE) . '</pre>';

  // Comment next three because it triggers full load.
  $array = $config->getSection('system.performance');
  $content[]['#markup'] = "<h3>system.performance section</h3>";
  $content[]['#markup'] = '<pre>' . print_r($array, TRUE) . '</pre>';

  // Same here, and because this output seems unrevelant.
  $array = $config->toArray();
  $content[]['#markup'] = "<h3>toArray()</h3>";
  $content[]['#markup'] = '<pre>' . print_r($array, TRUE) . '</pre>';

  return $content;
}

function oox_schema_test_merge_page() {
  $content = array();

  $a = new Schema_Array(array(
    'a' => array('aa' => 1, 'bb' => 2, 'cc' => 3),
    'b' => 2,
    'c' => array('d' => array('da' => 1, 'dc' => 3)),
  ));
  $c = clone $a;

  $b = new Schema_Array(array(
    'a' => array('aa' => 1, 'bb' => 'overrided', 'dd' => 4),
    'c' => array('d' => array('da' => 'overrided'), 'e' => array('ea' => 1)),
    'f' => 4,
  ));

  $a->merge($b, TRUE);
  $c->merge($b, FALSE);

  print_r($a);
  print_r($c);
  die();
}
