<?php
// $Id$

/**
 * @file
 * Oox Admin UI pages.
 */

/**
 * Global configuration form.
 */
function oox_lock_settings($form, &$form_state) {
  $form = array();

  $form[OOX_VAR_LOCK_BACKEND] = array(
    '#type' => 'select',
    '#title' => t("Lock backend"),
    '#description' => t("Depending on your environment, some backends could be faster than others. If you are using memcache or APC as Drupal core cache backend, you might want to switch to the cache backend. Default is database backend, and will work for all users."),
    '#options' => array(
      0 => t("Database backend"),
      // 'OoxLockCache' => t("Cache backend"),
    ),
    '#default_value' => variable_get(OOX_VAR_LOCK_BACKEND, 0),
  );

  $form = system_settings_form($form);

  $form['actions']['rebuild'] = array(
    '#type' => 'submit',
    '#value' => t("Rebuild object cache"),
    '#attributes' => array(
      'title' => t("This will rebuild the object cache without flushing the full Drupal cache. Notice that it will also clear the menu cache in order for items to display correctly in administration pages. It can help in some edge cases where your cache did not rebuild correctly."),
    ),
    '#submit' => array('oox_common_settings_submit_rebuild'),
  );

  return $form;
}

function oox_lock_settings_submit_rebuild($form, &$form_state) {
  cache_clear_all('*', OOX_CACHE_TABLE, TRUE);
  menu_rebuild();
  drupal_set_message(t("Object cache cleared."));
}
